<?php
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.plugin.plugin');

class plgUserPap4 extends JPlugin {

    function plgUserPap4(& $subject, $config) {
        parent::__construct($subject, $config);
    }

    function onAfterStoreUser($user, $isnew, $succes, $msg) {
        global $mainframe;

        if ($isnew) {
            // here we start executing our API code
            require('PapApi.class.php');
            try {
                // login to API
                $session = new Gpf_Api_Session("http://demo.qualityunit.com/pax4/scripts/server.php");
                if(!$session->login("merchant@example.com", "demo")) {
                    // cannot login to API
                    // do something with the error
                    return;
                }

                //identify the referrer (affiliate)
                $clickTracker = new Pap_Api_ClickTracker($session);
                try {
                    $clickTracker->track();
                    $clickTracker->saveCookies();

                    $affiliate = $clickTracker->getAffiliate();
                    $referralid = '';

      	            //if cookies were found - so an affiliate was recongized as a referrer
      	            if ($affiliate !== null) {
      		           $referralid = @$affiliate->getParam('refid'); //get the referral id of the referring affiliate
      	            }
                }
                catch (Exception $e) {
                    //echo("No parent affiliate recognized: ".$e->getMessage());
                }

                // create new affiliate
                $affiliate = new Pap_Api_Affiliate($session);
                $affiliate->setUsername($user['email']);
                $affiliate->setPassword($user['password_clear']);
                $affiliate->setFirstname('Joomla');
                $affiliate->setLastname($user['fullname']);
                if ($referralid != '') $affiliate->setParentUserId($referralid); //setting the parent affiliate

                if(!$affiliate->add()) {
                    // cannot add record
                    // do something with the error
                    return;
                } else {
                    // affiliate was successfully added
                }
            } catch(Exception $e) {
                // do something with the error
                return;
            }
        }
    }
}